'use strict';

exports.__esModule = true;
exports.MainMenu = exports.styles = undefined;

var _class, _temp2;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _context2 = require('@prisma-cms/context');

var _context3 = _interopRequireDefault(_context2);

var _AppBar = require('material-ui/AppBar');

var _AppBar2 = _interopRequireDefault(_AppBar);

var _Toolbar = require('material-ui/Toolbar');

var _Toolbar2 = _interopRequireDefault(_Toolbar);

var _Button = require('material-ui/Button');

var _Button2 = _interopRequireDefault(_Button);

var _Typography = require('material-ui/Typography');

var _Typography2 = _interopRequireDefault(_Typography);

var _reactRouterDom = require('react-router-dom');

var _User = require('./User');

var _User2 = _interopRequireDefault(_User);

var _styles = require('material-ui/styles');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectDestructuringEmpty(obj) { if (obj == null) throw new TypeError("Cannot destructure undefined"); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// console.log("MainMenu Context", Context);

// import Modal from './AuthModal';

var styles = exports.styles = function styles(theme) {
  var paletteType = theme.palette.type;


  return {
    root: {

      // Fix contrast 
      // "& a, & button": {
      //   "&, & *": {
      //     color: paletteType === "light" ? "#fff" : undefined,
      //   },
      // },
    },
    link: {
      color: paletteType === "light" ? "#fff" : undefined
    }
  };
};

var MainMenu = exports.MainMenu = (_temp2 = _class = function (_PureComponent) {
  _inherits(MainMenu, _PureComponent);

  function MainMenu() {
    var _temp, _this, _ret;

    _classCallCheck(this, MainMenu);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _PureComponent.call.apply(_PureComponent, [this].concat(args))), _this), _this.state = {
      // opened: false,
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  // static contextTypes = {
  //   logout: PropTypes.func.isRequired,
  //   onAuthSuccess: PropTypes.func.isRequired,
  //   user: PropTypes.object,
  //   openLoginForm: PropTypes.func.isRequired,
  // }


  MainMenu.prototype.logout = function logout() {
    var logout = this.context.logout;


    logout();
  };

  // componentWillMount(){
  //   console.log("menu componentWillMount");
  // }

  // handleClose = () => {

  //   this.setState({
  //     opened: false,
  //   });

  // }


  MainMenu.prototype.render = function render() {
    var _this2 = this;

    var _context = this.context,
        user = _context.user,
        Grid = _context.Grid;

    _objectDestructuringEmpty(this.state);

    var classes = this.props.classes;

    var _ref = user || {},
        userId = _ref.id,
        sudo = _ref.sudo;

    return _react2.default.createElement(
      _AppBar2.default
      // position="relative"
      ,
      { className: classes.root,
        style: {
          position: "relative"
        }
      },
      _react2.default.createElement(
        Grid,
        {
          container: true,
          spacing: 16,
          alignItems: 'center',
          className: 'MainMenu-root'
        },
        _react2.default.createElement(
          Grid,
          {
            item: true
          },
          _react2.default.createElement(
            _reactRouterDom.Link,
            {
              to: '/'
            },
            _react2.default.createElement(
              _Typography2.default,
              {
                component: 'span',
                className: classes.link
              },
              'Main page'
            )
          )
        ),
        _react2.default.createElement(
          Grid,
          {
            item: true
          },
          _react2.default.createElement(
            _reactRouterDom.Link,
            {
              to: '/users'
            },
            _react2.default.createElement(
              _Typography2.default,
              {
                component: 'span',
                className: classes.link
              },
              'Users'
            )
          )
        ),
        _react2.default.createElement(
          Grid,
          {
            item: true
          },
          _react2.default.createElement(
            'a',
            {
              href: '/graphql-voyager'
            },
            _react2.default.createElement(
              _Typography2.default,
              {
                component: 'span',
                className: classes.link
              },
              'Graphql Voyager'
            )
          )
        ),
        _react2.default.createElement(Grid, {
          item: true,
          xs: true
        }),
        user ? [_react2.default.createElement(
          Grid,
          {
            key: 'user',
            item: true
          },
          _react2.default.createElement(_User2.default, {
            key: userId,
            user: user,
            classes: classes
          })
        ), _react2.default.createElement(
          Grid,
          {
            key: 'logout',
            item: true
          },
          _react2.default.createElement(
            _Button2.default,
            {
              onClick: function onClick() {
                return _this2.logout();
              },
              className: classes.link
            },
            'Signout'
          )
        )] : _react2.default.createElement(
          Grid,
          {
            key: 'login',
            item: true
          },
          _react2.default.createElement(
            _Button2.default,
            {
              onClick: function onClick(e) {
                // this.setState({
                //   opened: true,
                // });
                var openLoginForm = _this2.context.openLoginForm;

                openLoginForm();
              }
            },
            _react2.default.createElement(
              _Typography2.default,
              {
                component: 'span',
                className: classes.link
              },
              'Signin'
            )
          )
        )
      )
    );
  };

  return MainMenu;
}(_react.PureComponent), _class.contextType = _context3.default, _temp2);
MainMenu.propTypes = process.env.NODE_ENV !== "production" ? {
  classes: _propTypes2.default.object.isRequired } : {};
exports.default = (0, _styles.withStyles)(styles)(function (props) {
  return _react2.default.createElement(MainMenu, props);
});