'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _layout = require('../layout');

var _layout2 = _interopRequireDefault(_layout);

var _App = require('../../../App');

var _App2 = _interopRequireDefault(_App);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var DevMainPage = function (_Page) {
  _inherits(DevMainPage, _Page);

  function DevMainPage() {
    var _temp, _this, _ret;

    _classCallCheck(this, DevMainPage);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _Page.call.apply(_Page, [this].concat(args))), _this), _this.forceUpdateBind = function (event) {
      return _this.forceUpdate();
    }, _this.forceUpdateFakeBind = function () {
      return _this.forceUpdateFake();
    }, _this.setStateBind = function (event) {
      return _this.setState({
        new_date: new Date()
      });
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  DevMainPage.prototype.forceUpdateFake = function forceUpdateFake() {

    // console.log("forceUpdate", callback);

    Object.assign(this.state, {
      currentDate: new Date()
    });

    this.forceUpdate();
  };

  DevMainPage.prototype.render = function render() {
    var _props = this.props,
        staticContext = _props.staticContext,
        children = _props.children,
        other = _objectWithoutProperties(_props, ['staticContext', 'children']);

    /**
     * При обновлении компонента если передавать children,
     * то это всегда изменяемые свойства, если это новый инстанс, 
     * а не простое скалярное значение.
     */

    // <Fragment>
    //   <div>
    //     <button
    //       onClick={this.forceUpdateBind}
    //     >
    //       Force update
    //       </button>

    //     <button
    //       onClick={this.forceUpdateFakeBind}
    //     >
    //       Force update with fake
    //       </button>

    //     <button
    //       onClick={this.setStateBind}
    //     >
    //       Change state
    //       </button>

    //   </div>

    //   <App
    //     props={this.props}
    //     state={this.state}
    //     context={this.context}
    //   // children={(<div>
    //   //   Children
    //   // </div>)}
    //   >
    //     {/* {new Date().toString()} */}
    //     Text
    //     </App>

    // </Fragment>


    return _Page.prototype.render.call(this, _react2.default.createElement(
      'div',
      null,
      _react2.default.createElement(
        'div',
        {
          id: 'buttons'
        },
        _react2.default.createElement(
          'button',
          {
            onClick: this.forceUpdateBind
          },
          'Force update'
        ),
        _react2.default.createElement(
          'button',
          {
            onClick: this.forceUpdateFakeBind
          },
          'Force update with fake'
        ),
        _react2.default.createElement(
          'button',
          {
            onClick: this.setStateBind
          },
          'Change state'
        )
      ),
      _react2.default.createElement(
        'div',
        {
          id: 'content'
        },
        _react2.default.createElement(_App2.default, _extends({
          children: children || "Main page",
          props: this.props,
          state: this.state,
          context: this.context
        }, other))
      )
    ));
  };

  return DevMainPage;
}(_layout2.default);

exports.default = DevMainPage;
module.exports = exports['default'];